#define _arch_dreamcast
#include <kos.h>

#include "midi.h"

/* test program */

int check_start() {
	uint8 mcont = 0;
	cont_cond_t cond;
	static int prev_buttons;
	int buttons,changed;

	mcont = maple_first_controller();
	if (!mcont)
		return 0;

	/* Check for start on the controller */
	if (cont_get_cond(mcont, &cond) < 0)
		return 0;

	buttons = cond.buttons^0xffff;
	changed = buttons^prev_buttons;
	if (changed & CONT_A) {
	}
	prev_buttons = buttons;

	if (!(cond.buttons & CONT_START)) {
		printf("Pressed start\n");
		return 1;
	}

	return 0;
}


void *load_file(const char *name)
{
	int fd = fs_open(name,O_RDONLY);
	size_t size;
	void *buf;

	if (fd==0) return NULL;
	size = fs_total(fd);
	buf = malloc(size);
	fs_read(fd,buf,size);
	fs_close(fd);

	return buf;
}

void vsync_handler(unsigned int code)
{
	midi_callback();
	/* default handler */
	maple_vbl_irq_hnd(code);
}

extern uint8 romdisk[];
KOS_INIT_ROMDISK(romdisk);

int main()
{
	void *buf;

	spu_init();

//	fs_chdir("/pc/prog/midi");

	fs_chdir("/rd");

	buf = load_file("e1m1.mid");;
	if (buf==NULL) return -1;

	midi_alloc_voice(0,32);
	midi_alloc_mem(16,2*1024*1024-16);

	midi_load_patchs("mini.cfg","mini",LOAD_ADPCM);

	asic_evt_set_handler(ASIC_EVT_PVR_VBLINT, vsync_handler);

	midi_play(buf,1);

	while (!check_start() && midi_isplay()) {
	//	midi_callback();
		usleep(1000*1000/60);
	}
}
